d7323fdf0e9d1ee29ff4c3cf8e8d035cf752aacd
[distro-setup] / conflink
1 #!/bin/bash
2
3 source /a/bin/errhandle/err
4 err-cleanup() {
5 echo 1 >~/.local/conflink
6 }
7
8
9 usage() {
10 cat <<EOF
11 Usage: ${0##*/} [OPTIONS]
12 Link or otherwise install configuration files.
13
14 -f For fast. Dont use lnf, use ln -sf. Good for updating existing files.
15 EOF
16 exit $1
17 }
18
19
20 m() {
21 echo "$*"
22 "$@"
23 }
24 s() { sudo "$@"; }
25
26 lnf() { /a/exe/lnf "$@"; }
27
28 fast=false
29 if [[ $1 == -f ]]; then # f for fast
30 fast=true
31 shift
32 elif
33 [[ $1 ]]; then
34 echo "error: unrecognized arguments" >&2
35 exit 0
36 fi
37
38 if $fast; then
39 lnf() { ln -sf "$@"; }
40 fi
41
42 shopt -s nullglob
43 shopt -s extglob
44 shopt -s dotglob
45
46 # If we make a link back to the root, we stop going deeper into subdir_files.
47 # This makes it so we can do subdir directories. eg
48 # /p/c/subdir_files/.config/gajim -> ../../gagim
49 #
50 # Also note, under filesystem/, symlinks are expanded.
51
52 subdir-link-r() {
53 local root="$1"
54 local targets=()
55 if [[ $2 ]]; then
56 targets=( "$2"/!(.git|..|.|.#*) )
57 else
58 for f in "$1"/!(.git|..|.|.#*); do
59 if [[ -d $f ]]; then targets+=("$f"); fi
60 done
61 fi
62 local below
63 below="$( readlink -f "$root/..")"
64 for path in "${targets[@]}"; do
65 local fullpath
66 fullpath="$(readlink -f "$path")"
67 if [[ -f $path || $(dirname "$fullpath") == "$below" ]]; then
68 m lnf -T "$path" "$HOME/${path#$root/}"
69 elif [[ -d "$path" ]]; then
70 subdir-link-r "$root" "$path"
71 fi
72 done
73 }
74
75
76 common-file-setup() {
77 local dir fs x f reload_systemd
78 local -a reload_services
79 local -a restart_services
80 reload_systemd=false
81 for dir in "$@"; do
82 fs=$dir/filesystem
83 if [[ -e $fs && $user =~ ^iank?$ ]]; then
84 cmd=( s rsync -aiSAX --chown=root:root --chmod=g-s
85 --exclude=/etc/dovecot/users
86 --exclude='/etc/exim4/passwd*'
87 --exclude='/etc/exim4/*.pem'
88 $fs/ / )
89 echo "${cmd[@]@Q}"
90 while read -r line; do
91 file="${line:12}"
92 case $file in
93 etc/systemd/system/*)
94 reload_systemd=true
95 ;;
96 etc/dnsmasq.d/*)
97 restart_services+=(dnsmasq)
98 ;;
99 etc/systemd/resolved.conf.d/*)
100 restart_services+=(systemd-resolved)
101 ;;
102 esac
103 # Previously did this with tar, but it doesn't
104 # update directory permissions.
105 #
106 # S = do spare files efficiently
107 # A = preserve acls
108 # X = preserve extended attributes
109 # i = itemize
110 done < <("${cmd[@]}")
111 fi
112
113 if [[ -e $dir/subdir_files ]]; then
114 m subdir-link-r $dir/subdir_files
115 fi
116 local x=( $dir/!(binds|subdir_files|filesystem|machine_specific|..|.|.#*) )
117 (( ${#x[@]} >= 1 )) || continue
118 m lnf ${x[@]} ~
119 done
120 if $reload_systemd; then
121 m s systemctl daemon-reload
122 fi
123 for service in ${restart_services[@]}; do
124 if systemctl is-active $service >/dev/null; then
125 m s systemctl restart $service
126 fi
127 done
128 }
129
130 user=$(id -un)
131 all_dirs=({/a/bin/ds,/p/c}{,/machine_specific/$HOSTNAME})
132 # note, we assume a group of hosts does not have the
133 # same name as a single host, which is no problem on our scale.
134 for x in /p/c/machine_specific/*.hosts /a/bin/ds/machine_specific/*.hosts; do
135 if grep -qxF $HOSTNAME $x; then all_dirs+=( ${x%.hosts} ); fi
136 done
137
138 # old files 2022-03
139 for t in systemstatus epanicclean btrfsmaintstop dynamicipupdate; do
140 f=/etc/systemd/system/$t.timer
141 if [[ -e $f ]]; then
142 s systemctl stop $t.timer
143 s systemctl disable $t.timer
144 s rm -fv $f
145 reload_systemd=true
146 fi
147 done
148
149 c_dirs=(/a/c{,/machine_specific/$HOSTNAME})
150 case $user in
151 iank)
152 /a/bin/ds/install-my-scripts
153 files=(/p/c/machine_specific/*/filesystem/etc/ssh/*_key
154 /p/c/machine_specific/*/filesystem/etc/openvpn/client/*.key
155 /p/c/filesystem/etc/openvpn/client/*.key
156 /p/c/filesystem/etc/openvpn/easy-rsa/keys/*.key
157 )
158 if [[ -e ${files[0]} ]]; then
159 chmod 600 ${files[@]}
160 fi
161 # p needs to go first so .ssh link is created, then config link inside it
162 m common-file-setup ${all_dirs[@]}
163
164 #### begin special extra stuff ####
165 install -d -m700 ~/gpg-agent-socket
166
167 f=/var/lib/bind
168 if [[ -e $f ]]; then
169 # reset to the original permissions.
170 m s chgrp -R bind $f
171 m s chmod g+w $f
172 fi
173 sudo bash -c 'shopt -s nullglob; for f in /etc/bind/*.key /etc/bind/*.private /etc/bind/key.*; do chgrp bind $f; done'
174 if [[ -e /etc/caldav-htpasswd ]] && getent group www-data &>/dev/null; then
175 s chgrp www-data /etc/caldav-htpasswd
176 fi
177 if [[ -e /var/lib/znc ]] && getent group znc; then
178 s chown -R znc:znc /var/lib/znc
179 fi
180 for f in /etc/prometheus-{,export-}htpasswd; do
181 if [[ -e $f ]]; then
182 s chmod 640 $f
183 if getent passwd www-data; then
184 s chown root:www-data $f
185 fi
186 fi
187 done
188 f=/etc/prometheus-pass
189 if [[ -e $f ]]; then
190 # note: this is duplicative of the file's own permissions
191 s chmod 640 $f /etc/prometheus-pass
192 if getent passwd prometheus; then
193 s chown root:prometheus $f
194 fi
195 fi
196
197
198 ##### end special extra stuff #####
199
200 m sudo -H -u user2 "${BASH_SOURCE[0]}"
201
202 f=/a/bin/distro-setup/system-status
203 if [[ -x $f ]]; then
204 $f _
205 fi
206 mkdir -p ~/.local
207 echo 0 >~/.local/conflink
208
209 ;;
210 user2)
211 m common-file-setup ${c_dirs[@]}
212 ;;
213 *)
214 echo "$0: error: unexpected user"; exit 1
215 ;;
216 esac